<script setup>
import AuthenticatedLayout from '@/Layouts/AuthenticatedLayout.vue';
import { Head } from '@inertiajs/vue3';

</script>

<template>
    <Head title="Dashboard" />

    <AuthenticatedLayout :user="user">
        <div class="container-fluid">

            <!-- Page Heading -->
            <div class="d-sm-flex align-items-center justify-content-between mb-4">
                <h1 class="h3 mb-0 text-gray-800">Report Absensi</h1>
            </div>

            <div class="row" v-for="item in pegawai">
                <div class="col-xl-12">
                    <div class="card border-0  mb-4">
                        <div class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Absensi {{ item.name }}</h6>
                            <!-- Display total late minutes -->
                        </div>
                        <div class="card-body">
                            <h5 class="my-4">Rincian</h5>
                            <table cellpadding="10">
                                <tr>
                                    <td>Total Menit terlambat</td>
                                    <td>: </td>
                                    <td>{{ calculateTotalLateMinutes(item.absensi) }} Menit</td>
                                </tr>
                                <tr>
                                    <td>Gaji pokok</td>
                                    <td>: </td>
                                    <td>Rp. {{ baseSalary.toLocaleString() }}</td>
                                </tr>
                                <tr>
                                    <td>Potongan Per Menit </td>
                                    <td>: </td>
                                    <td> Rp. {{ salaryPerCut.toLocaleString() }}</td>
                                </tr>
                                <tr>
                                    <td>Gaji diterima </td>
                                    <td>: </td>
                                    <td>Rp. {{
                                        calculateSalary(calculateTotalLateMinutes(item.absensi)).toLocaleString()
                                    }}</td>
                                </tr>
                                <tr>
                                    <td>Gaji terpotong </td>
                                    <td>: </td>
                                    <td> Rp. {{ (baseSalary -
                                        calculateSalary(calculateTotalLateMinutes(item.absensi))).toLocaleString() }}</td>
                                </tr>
                                <tr>
                                    <td>Total hari terlambat </td>
                                    <td>: </td>
                                    <td>{{ calculateLateCount(item.absensi) }}</td>
                                </tr>
                                <tr>
                                    <td>Total hari masuk </td>
                                    <td>: </td>
                                    <td>{{ item.absensi.length }}</td>
                                </tr>
                            </table>



                            <h5 class="my-4">Detail Absen</h5>

                            <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                                <thead>
                                    <tr>
                                        <th>check in</th>
                                        <th>check out</th>
                                        <th>lokasi check in</th>
                                        <th>lokasi check out</th>
                                        <th>Menit terlambat</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="absen in item.absensi"
                                        :class="isLate(absen.check_in) > 0 ? 'bg-danger text-white' : ''">
                                        <td>{{ absen.check_in }}</td>
                                        <td>{{ absen.check_out == null ? '---' : absen.check_out }}</td>
                                        <td>
                                            <a target="_blank"
                                                :href="'https://www.google.com/maps/place/' + absen.check_in_long_lat"
                                                class="badge badge-primary">
                                                <i class="fas fa-map-marker-alt"></i>
                                                lihat</a>
                                        </td>
                                        <td>
                                            <a target="_blank"
                                                :href="'https://www.google.com/maps/place/' + absen.check_out_long_lat"
                                                class="badge badge-primary">
                                                <i class="fas fa-map-marker-alt"></i>
                                                lihat</a>
                                        </td>
                                        <td>
                                            {{ isLate(absen.check_in) }} Menit
                                        </td>
                                    </tr>

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </AuthenticatedLayout>
</template>

<script>
export default {
    props: {
        user: Object,
        pegawai: Object,
        baseSalary: Number,
        salaryPerCut: Number,
    },
    methods: {
        isLate(checkIn) {
            const cutoffTime = new Date();
            cutoffTime.setHours(9, 0, 0); // Set cutoff time to 09:00:00

            const checkInTime = new Date();
            const [hours, minutes, seconds] = checkIn.split(':');
            checkInTime.setHours(hours, minutes, seconds); // Set check-in time

            const lateMinutes = Math.max(0, (checkInTime - cutoffTime) / (1000 * 60)); // Calculate the difference in minutes

            return Math.floor(lateMinutes); // Return the total late minutes as an integer
        },
        calculateTotalLateMinutes(absensi) {
            let totalLateMinutes = 0; // Initialize totalLateMinutes for each employee

            absensi.forEach((absen) => {
                const lateMinutes = this.isLate(absen.check_in); // Calculate late minutes for each check-in time
                totalLateMinutes += lateMinutes; // Add late minutes to the total for the employee
            });

            return Math.floor(totalLateMinutes); // Return the total late minutes as an integer
        },
        calculateLateCount(absensi) {
            let lateCount = 0;
            for (const absen of absensi) {
                const lateMinutes = this.isLate(absen.check_in);
                if (lateMinutes > 0) {
                    lateCount++;
                }
            }
            return lateCount;
        },
        calculateSalary(lateMinutes) {

            const cuts = Math.floor(lateMinutes / 10); // Calculate the number of salary cuts
            const totalCut = cuts * this.salaryPerCut; // Calculate the total amount to be deducted from the salary

            return this.baseSalary - totalCut; // Calculate the final salary after deductions
        },
    },
}
</script>
